#
# SchoolTool - common information systems platform for school administration
# Copyright (c) 2015 Shuttleworth Foundation
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
"""
Evolve database to generation 1.

Adds new debit attributes
"""

from zope.app.generations.utility import getRootFolder

from schooltool.schoolyear.interfaces import ISchoolYearContainer
from schooltool.fee.interfaces import IFeeContainer
from schooltool.fee.interfaces import IDebit


def evolve(context):
    app = getRootFolder(context)
    schoolyears = ISchoolYearContainer(app)
    for schoolyear in schoolyears.values():
        container = IFeeContainer(schoolyear)
        for fee in container.values():
            if IDebit.providedBy(fee):
                fee.label = fee.title[:7]
                fee.last_date = fee.date
    persons = app['persons']
    for person in persons.values():
        fees = IFeeContainer(person)
        for fee in fees.values():
            if IDebit.providedBy(fee):
                fee.label = fee.title[:7]
                fee.last_date = fee.date
